unit uMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls
  ,fpreport
  ,dbf
  ,fpreportdb
  ,fpttf
  ,fpreportpdfexport
  ,fpReportStreamer
  ,fpjson
  ;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private

  public
    procedure LoadReportDesign(aReport :TFPCustomReport; aFileFprPath: string);
  end;

var
  Form1: TForm1;

implementation

{$R *.frm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
var
  _rpt: TFPCustomReport;
  _masterDataSet: TDBF;
  _reportMasterData: TFPReportDatasetData;
  _detailDataSet: TDBF;
  _reportDetailData: TFPReportDatasetData;
  _rptExporter: TFPReportExporter;

begin
  _rptExporter := nil;

  {$REGION 'CheckFile'}
  if not FileExists('data\master.dbf') then
  begin
    writeln('Unable to find database file <master.dbf>!');
    writeln('');
    exit;
  end;

  if not FileExists('data\detail.dbf') then
  begin
    writeln('Unable to find database file <detail.dbf>!');
    writeln('');
    exit;
  end;
  {$ENDREGION}

  // ***** Providing data to the report *****
  _reportMasterData := TFPReportDatasetData.Create(nil);
  _reportMasterData.Name:='master';
  _masterDataSet := TDBF.Create(nil);
  _masterDataSet.TableName := 'data\master.dbf';
  _masterDataSet.Name:='master';
  _reportMasterData.DataSet := _masterDataSet;

  _reportDetailData := TFPReportDatasetData.Create(nil);
  _reportMasterData.Name:='detail';
  _detailDataSet := TDBF.Create(nil);
  _detailDataSet.TableName := 'data\detail.dbf';
  _detailDataSet.Name:='detail';
  _reportDetailData.DataSet := _detailDataSet;

  _rpt := TFPCustomReport.Create(self);
  self.LoadReportDesign(_rpt, 'data\test.json');



  TFPReportDataBand(_rpt.FindRecursive('DataBandMasterHeader')).Data := _reportMasterData;
  TFPReportDataBand(_rpt.FindRecursive('DataBandMaster')).Data := _reportMasterData;

  TFPReportDataBand(_rpt.FindRecursive('DataBandDetail')).Data := _reportDetailData;
  TFPReportDataBand(_rpt.FindRecursive('DataBandDetail')).MasterBand := TFPReportDataBand(_rpt.FindRecursive('DataBandMaster'));

  try
    // ***** Running the report *****
    gTTFontCache.SearchPath.Add('fonts\');
    gTTFontCache.BuildFontCache;
    _rpt.RunReport;

    // ***** Rendering (or exporting) the report *****
    if Assigned(_rptExporter) then
      FreeAndNil(_rptExporter);

    _rptExporter := TFPReportExportPDF.Create(nil);
    _rpt.RenderReport(_rptExporter);

    ShowMessage('File created.');

  finally
    // Freeing all objects we used
    FreeAndNil(_rptExporter);
    FreeAndNil(_rpt);
    FreeAndNil(_reportMasterData);
    FreeAndNil(_masterDataSet);
    //FreeAndNil(_reportDetailData);
    //FreeAndNil(_detailDataSet);
  end;
end;

procedure TForm1.LoadReportDesign(aReport: TFPCustomReport; aFileFprPath: string);
Var
  J : TFPReportJSONStreamer;
  F : TFileStream;
  O : TJSONObject;

begin
  J:=Nil;
  F:=TFileStream.Create(aFileFprPath,fmOpenRead);
  try
    O:=GetJSON(F) as TJSONObject;
    J:=TFPReportJSONStreamer.Create(Self);
    J.JSON:=O;
    J.OwnsJSON:=True;
    aReport.ReadElement(j);
  finally
    F.Free;
    J.Free;
  end;
end;

end.

